﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

//
using SBUS;

namespace DemoForServiceCall
{
    public partial class Form1 : Form
    {
        ServiceCall com = new ServiceCall();

        public Form1()
        {
            InitializeComponent();

            this.Load += new EventHandler(Form1_Load);

            com.DataArrival += new Communication.DataArrivalHandler(com_DataArrival);

            button1.Click += new EventHandler(button1_Click);

            picCardHolder.MouseMove += new MouseEventHandler(picCardHolder_MouseMove);
            picCardHolder.MouseClick += new MouseEventHandler(picCardHolder_MouseClick);
        }

        void picCardHolder_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Y >= 303 && e.Y <= 345)
            {
                if (e.X >= 56 && e.X <= 133)
                {
                    if (picLaundry_Off.Visible)
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_LAUNDRY, ServiceCallStatus.SCS_ON);
                    }
                    else
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_LAUNDRY, ServiceCallStatus.SCS_OFF);
                    }
                }
                else if (e.X >= 180 && e.X <= 257)
                {
                    if (picDND_Off.Visible)
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_DND, ServiceCallStatus.SCS_ON);
                    }
                    else
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_DND, ServiceCallStatus.SCS_OFF);
                    }
                }
                else if (e.X >= 302 && e.X <= 380)
                {
                    if (picClean_Off.Visible)
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_CLEAN, ServiceCallStatus.SCS_ON);
                    }
                    else
                    {
                        com.Write_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value, ServiceCallType.SCT_CLEAN, ServiceCallStatus.SCS_OFF);
                    }
                }
            }
        }

        void picCardHolder_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Y >= 303 && e.Y <= 345)
            {
                if (e.X >= 56 && e.X <= 133)
                {
                    this.Cursor = Cursors.Hand;
                }
                else if (e.X >= 180 && e.X <= 257)
                {
                    this.Cursor = Cursors.Hand;
                }
                else if (e.X >= 302 && e.X <= 380)
                {
                    this.Cursor = Cursors.Hand;
                }
                else
                {
                    this.Cursor = Cursors.Default;
                }
            }
            else
            {
                this.Cursor = Cursors.Default;
            }
        }

        void button1_Click(object sender, EventArgs e)
        {
            com.Read_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            com.localIPAddress = "0.0.0.0";

            com.InitSocket(PortType.PT_LAN);

            com.Read_Card_Holder_Service_Call_Status((byte)numericUpDown1.Value, (byte)numericUpDown2.Value);
        }

        void com_DataArrival(byte subnetID, byte deviceID, int deviceType, OperateCodeResponse ocr, int lengthOfAddtional, ref byte[] addtional)
        {
            byte[] addtional_Delegate = addtional;

            this.Invoke(new Action(delegate
            {
                if (subnetID == (byte)numericUpDown1.Value && deviceID == (byte)numericUpDown2.Value)
                {
                    switch (ocr)
                    {
                        case OperateCodeResponse.OCR_SERVICE_CALL_CONTROL_CARD_HOLDER_SERVICE_CALL_STATUS:
                            switch (addtional_Delegate[0])
                            {
                                case 1: //Clean
                                    picClean_On.Visible = addtional_Delegate[1] == 1;
                                    picClean_Off.Visible = addtional_Delegate[1] == 0;

                                    if (addtional_Delegate[1] == 1)
                                    {
                                        picDND_On.Visible = false;
                                        picDND_Off.Visible = true;
                                    }
                                    break;
                                case 2: //DND
                                    picDND_On.Visible = addtional_Delegate[1] == 1;
                                    picDND_Off.Visible = addtional_Delegate[1] == 0;

                                    if (addtional_Delegate[1] == 1)
                                    {
                                        picClean_On.Visible = false;
                                        picClean_Off.Visible = true;

                                        picLaundry_On.Visible = false;
                                        picLaundry_Off.Visible = true;
                                    }
                                    break;
                                case 3: //Laundry
                                    picLaundry_On.Visible = addtional_Delegate[1] == 1;
                                    picLaundry_Off.Visible = addtional_Delegate[1] == 0;

                                    if (addtional_Delegate[1] == 1)
                                    {
                                        picDND_On.Visible = false;
                                        picDND_Off.Visible = true;
                                    }
                                    break;
                            }
                            break;
                        case OperateCodeResponse.OCR_SERVICE_CALL_READ_CARD_HOLDER_SERVICE_CALL_STATUS:
                            picClean_On.Visible = false;
                            picClean_Off.Visible = true;
                            picDND_On.Visible = false;
                            picDND_Off.Visible = true;
                            picLaundry_On.Visible = false;
                            picLaundry_Off.Visible = true;

                            if (addtional_Delegate[0] == 1)
                            {
                                picClean_On.Visible = true;
                                picClean_Off.Visible = false;
                            }

                            if (addtional_Delegate[1] == 1)
                            {
                                picDND_On.Visible = true;
                                picDND_Off.Visible = false;
                            }

                            if (addtional_Delegate[2] == 1)
                            {
                                picLaundry_On.Visible = true;
                                picLaundry_Off.Visible = false;
                            }
                            break;
                        case OperateCodeResponse.OCR_SERVICE_CALL_WRITE_CARD_HOLDER_SERVICE_CALL_STATUS:
                            break;
                    }
                }
            }));
        }
    }
}
